﻿<%@ Page Language="C#" AutoEventWireup="true" CodeBehind="Default.aspx.cs" Inherits="WebApplication2._Default" %>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" >
<head runat="server">
    <title>제목 없음</title>
    <style type="text/css">
    body,table{
        font-family: 돋움 굴림;
	    font-size: 12px;
    }

    table{
        border-collapse: collapse;
        table-layout: fixed;
    }

    .btn{
        cursor: pointer;
    }

    .drag{
        position: absolute;
        cursor:move;
        padding: 5px;
    }

    .box{
        border: solid 1px #000000;
        background-color: #F4F4F4;
        width: 300px;
        font-size: 11px;
        font-family: 돋움;
        overflow: visible;
    }

    .box textarea{
        border-width: 0;
        background-color: #F4F4F4;
        width: 100%;
        overflow: visible;
        font-size: 11px;
        font-family: 돋움;
        padding: 5px;
    }

    #memo_status{
        float: left;
        width: 200px;
        clear: left;
    }

    #status{
        width: 100%;
        clear: both;
    }

    .mybox{
        border: solid 1px #000000;
        background-color: #FAE8A0;
        width: 300px;
        font-size: 11px;
        font-family: 돋움;
        overflow: visible;
    }

    .mybox textarea{
        border-width: 0;
        background-color: #FAE8A0;
        width: 100%;
        overflow: visible;
        font-size: 11px;
        font-family: 돋움;
        padding: 5px;
    }
    </style>
    
    <script language="JavaScript" type="text/javascript">
	document.onmousedown = mousedownIe;
	document.onmouseup = mouseupIe;
	document.onmousemove = moveingIe;

	String.prototype.trim = function(){
		return this.replace(/(^\s*|\s*$|\n)/g,"");
	}

	var dragObj;
	var x = 0;
	var y = 0;
	var dragObj_zindex;
	var dragObjCollection = new Array();
	var memoPosInfo = new Array();

	function mousedownIe(e) {
		var evt = e;
		var targetObj;
		var leftClick = false;

		if(window.event){
			evt = window.event;
			targetObj = evt.srcElement;

			if(evt.button == 1){
				leftClick = true;
			}
		}else{
			targetObj = e.target;

			if(evt.button == 0){
				leftClick = true;
			}
		}

		if(leftClick == true){
			if(isDragableLayer(targetObj) == true) {
				dragObj = targetObj;
				dragObj_zindex = dragObj.style.zIndex;
				dragObj.style.zIndex = dragObjCollection.length + 1;

				x = evt.clientX;
				y = evt.clientY;

				dragObj.style.borderWidth = 3;

			}
		}
	}

	function mouseupIe(e) {
		if(dragObj != null){
			dragObj.style.borderWidth = 1;
			dragObj.style.zIndex = dragObj_zindex;
		}

		dragObj = null;
	}

	function moveingIe(e) {
		var evt = e;
		var targetObj;

		if(window.event){
			evt = window.event;
			targetObj = evt.srcElement;
		}else{
			targetObj = e.target;
		}

		if(dragObj == targetObj) {
			var distX = evt.clientX - x;
			var distY = evt.clientY - y;

			var currentTop;
			var currentLeft;

			if(targetObj.style.left == ''){
				currentLeft = parseInt(targetObj.offsetLeft);
				currentTop = parseInt(targetObj.offsetTop);
			}else{
				currentLeft = parseInt(targetObj.style.left);
				currentTop = parseInt(targetObj.style.top);
			}

			var arriveLeft = currentLeft + distX;
			var arriveTop = currentTop + distY;

			targetObj.style.left = arriveLeft;
			targetObj.style.top = arriveTop;

			x = evt.clientX;
			y = evt.clientY;

			window.status = arriveLeft + ',' + arriveTop;

			return false;
		}
	}

	function box_reset(memoObj){
		if(typeof(memoPosInfo[memoObj.id]) != ''){
			memoObj.style.left = memoPosInfo[memoObj.id][0];
			memoObj.style.top = memoPosInfo[memoObj.id][1];
		}
	}

	//열린 메모 수
	function showMemoCount(){
		var memo_cnt_layer = document.getElementById('dragObj_status');
		var memo_cnt = document.createTextNode(dragObjCollection.length);

		memo_cnt_layer.replaceChild(memo_cnt,memo_cnt_layer.firstChild);
	}


	//객체의 드래그 가능 여부 반환
	function isDragableLayer(obj){
		if(obj.className.search('drag') >= 0){
			return true;
		}else{
			return false;
		}
	}

	//레이어 추가
	function addLayer()
	{
		var newDragLayer = document.createElement('DIV');
		var LayerText     = document.createElement('TEXTAREA');
		var btn_new_Layer = document.getElementById('btn_new_Layer');

		newDragLayer.className = 'drag box';
		newDragLayer.style.top = (btn_new_Layer.offsetTop + 100) +  'px';
		newDragLayer.style.left = btn_new_Layer.offsetLeft + 'px';

		newDragLayer.appendChild(LayerText);
		dragObjCollection.push(newDragLayer);
		newDragLayer.id = 'memo_' + dragObjCollection.length;
		showMemoCount();
		document.body.appendChild(newDragLayer);
		alert(newDragLayer.id);
	}


	//바둑판식 정렬
	function gridAlign(){
		if(dragObjCollection.length > 0){
			var leftpos = 20;
			var toppos = 100;
			var maxHeight = 0;

			for(var i=0,max=dragObjCollection.length; i<max; i++){
				dragObjCollection[i].style.left = leftpos + 'px';
				dragObjCollection[i].style.top = toppos + 'px';

				if(maxHeight < dragObjCollection[i].offsetHeight){
					maxHeight = dragObjCollection[i].offsetHeight;
				}

				leftpos += dragObjCollection[i].offsetWidth;

				if(i < max - 1 && leftpos + dragObjCollection[i + 1].offsetWidth > screen.width - 40){
					toppos += maxHeight;
					leftpos = 20;
					maxHeight = 0;
				}
			}
		}
	}

	//계단식 정렬
	function stairAlign(){
		if(dragObjCollection.length > 0){
			var leftpos = 100;
			var toppos = 100;

			for(var i=0,max=dragObjCollection.length; i<max; i++){
				dragObjCollection[i].style.left = leftpos + 'px';
				dragObjCollection[i].style.top = toppos + 'px';

				leftpos += 30;
				toppos += 30;
			}
		}
	}
    </script>
</head>
<body>
    <form id="form1" runat="server">
    <div id="status">
        <div id="memo_status">열린 메모: <span id="dragObj_status">0</span>개</div>
    </div>
    <input type="button" id="btn_Align_grid" value="바둑판식 정렬" onclick="gridAlign()" />
    <input type="button" id="btn_Align_stair" value="계단식 정렬" onclick="stairAlign()" />
    <input type="button" id="btn_new_Layer" value="레이어 추가" onclick="addLayer()" />
    </form>    
</body>
</html>
